﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading.Tasks;//追加

//*********** DMAを利用したLCDダイレクトドライブ　2010.12.01　H.GURITA *************************
namespace 表示データ作成プログラム
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            Task pic1 = Task.Factory.StartNew(delegate { Pic2hex(1, textBox1.Text, textBox2.Text); });
            Task pic2 = Task.Factory.StartNew(delegate { Pic2hex(2, textBox3.Text, textBox4.Text); });
            Task.WaitAll(pic1, pic2);
            pictureBox1.Image = (Bitmap)Bitmap.FromFile(textBox1.Text);
            pictureBox2.Image = (Bitmap)Bitmap.FromFile(textBox3.Text);
            button1.Enabled = true;
        }
        //ビットマップデータをHEX形式のテキストファイルに変換（2画像をパラレル処理）
        private static void Pic2hex(int n, string pic_dir, string hex_dir)//画像番号，画像ファイル名，HEXファイル名
        {
            Color col;
            int csum;//チェックサムSS
            int D;
            int P = 0;
            System.IO.StreamWriter textFile;
            textFile = System.IO.File.CreateText(hex_dir);
            Bitmap BB = (Bitmap)Bitmap.FromFile(pic_dir);
            //HEXファイルは最初に上位アドレス4バイトを指定し，続いて下位アドレス＋データを並べる
            //最初の65535バイトの処理
            if (n == 1)
            {
                textFile.Write(":020000040801F1" + Environment.NewLine);//画像1の上位アドレス
            }
            else if (n == 2)
            {
                textFile.Write(":020000040804EE" + Environment.NewLine);//画像2の上位アドレス
            }
            //":LLAAAADDD----DDSS"
            for (int A = 0; A <= 0xFFF0; A += 16)//32768ドットの処理
            {
                csum = 0;
                //"X4"は16進で4文字表示
                textFile.Write(":10" + A.ToString("X4") + "00");
                for (int k = 0; k < 8; k++)
                {
                    //色データは　G2G1G0R5 R4R3R2R1 B5B4B3B2 B1G5G4G3　のように並べる 
                    col = BB.GetPixel(P % 240, P / 240);//X = P % 240,Y = P / 240
                    D = ((col.G & 0x001C) << 11) | ((col.R & 0x00F8) << 5) | (col.B & 0x00F8) | (col.G >> 5);
                    csum += (((D >> 8) & 0x00FF) + (D & 0x00FF));
                    textFile.Write(D.ToString("X4"));
                    P++;
                }
                csum = (0x0100 - ((csum + 0x10 + ((A >> 8) & 0x00FF) + (A & 0x00FF)) & 0x00FF)) & 0x00FF;
                //"X2"は16進で2文字表示（有効桁数が2桁を超える場合は2桁にはならない：0x00000100は100となるので注意）
                textFile.Write(csum.ToString("X2") + Environment.NewLine);
            }
            //次の65535バイトの処理
            if (n == 1)
            {
                textFile.Write(":020000040802F0" + Environment.NewLine);
            }
            else if (n == 2)
            {
                textFile.Write(":020000040805ED" + Environment.NewLine);
            }
            for (int A = 0; A <= 0xFFF0; A += 16)
            {
                csum = 0;
                textFile.Write(":10" + A.ToString("X4") + "00");
                for (int k = 0; k < 8; k++)
                {
                    col = BB.GetPixel(P % 240, P / 240);
                    D = ((col.G & 0x001C) << 11) | ((col.R & 0x00F8) << 5) | (col.B & 0x00F8) | (col.G >> 5);
                    csum += (((D >> 8) & 0x00FF) + (D & 0x00FF));
                    textFile.Write(D.ToString("X4"));
                    P++;
                }
                csum = (0x0100 - ((csum + 0x10 + ((A >> 8) & 0x00FF) + (A & 0x00FF)) & 0x00FF)) & 0x00FF;
                textFile.Write(csum.ToString("X2") + Environment.NewLine);
            }
            //残りの処理
            if (n == 1)
            {
                textFile.Write(":020000040803EF" + Environment.NewLine);
            }
            else if (n == 2)
            {
                textFile.Write(":020000040806EC" + Environment.NewLine);
            }
            for (int A = 0; A <= 0x57F0; A += 16)//11264ドットの処理
            {
                csum = 0;
                textFile.Write(":10" + A.ToString("X4") + "00");
                for (int k = 0; k < 8; k++)
                {
                    col = BB.GetPixel(P % 240, P / 240);
                    D = ((col.G & 0x001C) << 11) | ((col.R & 0x00F8) << 5) | (col.B & 0x00F8) | (col.G >> 5);
                    csum += (((D >> 8) & 0x00FF) + (D & 0x00FF));
                    textFile.Write(D.ToString("X4"));
                    P++;
                }
                csum = (0x0100 - ((csum + 0x10 + ((A >> 8) & 0x00FF) + (A & 0x00FF)) & 0x00FF)) & 0x00FF;
                textFile.Write(csum.ToString("X2") + Environment.NewLine);
            }
            textFile.Close();
        }
    
    }
}
